window.Gleam.initSearch([{"doc":"formz_lustre","title":"formz_lustre","content":"# formz_lustre\n\n[![Package Version](https://img.shields.io/hexpm/v/formz_lustre)](https://hex.pm/packages/formz_lustre)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/formz_lustre/)\n\nLustre widgets and field definitions for the formz library.  See [formz](https://hexdocs.pm/formz/)\nfor details on how to use these.\n","url":"index.html"},{"doc":"formz_lustre","title":"main","content":"pub fn main() -&gt; Nil\n\nSynonyms:\nformz_lustre.main\nformz_lustre main","url":"formz_lustre.html#main"},{"doc":"formz_lustre","title":"formz_lustre","content":"","url":"formz_lustre.html"},{"doc":"formz_lustre/widget","title":"Args","content":"pub type Args {\n  Args(\n    id: String,\n    labelled_by: LabelledBy,\n    described_by: DescribedBy,\n  )\n}\n\nArgs(\n  id: String,\n  labelled_by: LabelledBy,\n  described_by: DescribedBy,\n)\n\nid\n&lt;p&gt;The id of the input element.&lt;/p&gt;\n\nlabelled_by\n&lt;p&gt;Details of how the input is labelled. Some sort of label is required for accessibility.&lt;/p&gt;\n\ndescribed_by\n&lt;p&gt;Details of how the input is described. This is optional, but can be useful for accessibility.&lt;/p&gt;\n\nSynonyms:\nformz_lustre/widget.Args\nformz_lustre/widget Args","url":"formz_lustre/widget.html#Args"},{"doc":"formz_lustre/widget","title":"DescribedBy","content":"pub type DescribedBy {\n  DescribedByElementsWithIds(ids: List(String))\n  DescribedByNone\n}\n\nDescribedByElementsWithIds(ids: List(String))\n The input is described by elements with the specified ids. This is useful\n for additional instructions or error messages.\n\nDescribedByNone\n\n\nSynonyms:\nformz_lustre/widget.DescribedBy\nformz_lustre/widget DescribedBy","url":"formz_lustre/widget.html#DescribedBy"},{"doc":"formz_lustre/widget","title":"LabelledBy","content":"pub type LabelledBy {\n  LabelledByLabelElement\n  LabelledByConfigValue\n  LabelledByElementsWithIds(ids: List(String))\n}\n\nLabelledByLabelElement\n The input is labelled by a `&lt;label&gt;` element with a `for` attribute\n pointing to this input&#39;s id. This has the best accessibility support\n and should be [preferred when possible](https://www.w3.org/WAI/tutorials/forms/labels/).\n\nLabelledByConfigValue\n The input should be labelled using the `formz.Config`&#39;s `label` field.\n\nLabelledByElementsWithIds(ids: List(String))\n The input is labelled by elements with the specified ids.\n\nSynonyms:\nformz_lustre/widget.LabelledBy\nformz_lustre/widget LabelledBy","url":"formz_lustre/widget.html#LabelledBy"},{"doc":"formz_lustre/widget","title":"Widget","content":"pub type Widget(msg) {\n  Widget(\n    fn(formz.Config, formz.InputState, Args) -&gt;\n      element.Element(msg),\n  )\n  Hidden\n}\n\nWidget(\n  fn(formz.Config, formz.InputState, Args) -&gt;\n    element.Element(msg),\n)\n\n\nHidden\n\n\nSynonyms:\nformz_lustre/widget.Widget\nformz_lustre/widget Widget","url":"formz_lustre/widget.html#Widget"},{"doc":"formz_lustre/widget","title":"checkbox_widget","content":"pub fn checkbox_widget() -&gt; Widget(a)\n Create an `&lt;input type=&quot;checkbox&quot;&gt;`. The checkbox is checked\n if the value is &quot;on&quot; (the browser default).\nSynonyms:\nformz_lustre/widget.checkbox_widget\nformz_lustre/widget checkbox_widget","url":"formz_lustre/widget.html#checkbox_widget"},{"doc":"formz_lustre/widget","title":"hidden_widget","content":"pub fn hidden_widget() -&gt; Widget(a)\n Create a `&lt;input type=&quot;hidden&quot;&gt;`. This is useful for if a field is just\n passing data around and you don&#39;t want it to be visible to the user. Like\n say, the ID of a record being edited.\nSynonyms:\nformz_lustre/widget.hidden_widget\nformz_lustre/widget hidden_widget","url":"formz_lustre/widget.html#hidden_widget"},{"doc":"formz_lustre/widget","title":"input_widget","content":"pub fn input_widget(type_: String) -&gt; Widget(a)\n Generate any `&lt;input&gt;` like `type=&quot;text&quot;`, `type=&quot;email&quot;` or\n `type=&quot;url&quot;`.\nSynonyms:\nformz_lustre/widget.input_widget\nformz_lustre/widget input_widget","url":"formz_lustre/widget.html#input_widget"},{"doc":"formz_lustre/widget","title":"number_widget","content":"pub fn number_widget(step_size: String) -&gt; Widget(a)\n Create a `&lt;input type=&quot;number&quot;&gt;`.  Normally browsers only allow whole numbers,\n unless a decimal step size is provided.  The step size here is a string that\n will be put straight into the `step-size` attribute.  Doing non-whole numbers\n this way does mean that a user can only input numbers up to the precision of\n the step size.  If you truly need any float, then a `type=&quot;text&quot;` input might be a\n better choice.\nSynonyms:\nformz_lustre/widget.number_widget\nformz_lustre/widget number_widget","url":"formz_lustre/widget.html#number_widget"},{"doc":"formz_lustre/widget","title":"password_widget","content":"pub fn password_widget() -&gt; Widget(a)\n Create an `&lt;input type=&quot;password&quot;&gt;`. This will not output the value in the\n generated HTML for privacy/security concerns.\nSynonyms:\nformz_lustre/widget.password_widget\nformz_lustre/widget password_widget","url":"formz_lustre/widget.html#password_widget"},{"doc":"formz_lustre/widget","title":"select_widget","content":"pub fn select_widget(\n  variants: List(#(String, String)),\n) -&gt; Widget(a)\n Create a `&lt;select&gt;&lt;/select&gt;` with `&lt;option&gt;`s for each variant.  The list\n of variants is a two-tuple, where the first item is the text to display and\n the second item is the value.\nSynonyms:\nformz_lustre/widget.select_widget\nformz_lustre/widget select_widget","url":"formz_lustre/widget.html#select_widget"},{"doc":"formz_lustre/widget","title":"textarea_widget","content":"pub fn textarea_widget() -&gt; Widget(a)\n Create a `&lt;textarea&gt;&lt;/textarea&gt;`.\nSynonyms:\nformz_lustre/widget.textarea_widget\nformz_lustre/widget textarea_widget","url":"formz_lustre/widget.html#textarea_widget"},{"doc":"formz_lustre/widget","title":"formz_lustre/widget","content":" The goal of a &quot;widget&quot; in `formz` is to produce an HTML input like\n `&lt;input&gt;`, `&lt;select&gt;`, or `&lt;textarea&gt;`. In a formz `Definition`\n a widget can be any Gleam type, and it&#39;s up to the form generator being\n used to know the exact type you need.\n\n In this generator, the widget is either a function that takes the details\n and state of a field, or a special value for a hidden field.","url":"formz_lustre/widget.html"},{"doc":"formz_lustre/definition","title":"boolean_field","content":"pub fn boolean_field() -&gt; Definition(Widget(a), Bool, Bool)\n Create a checkbox form input. Parsed as a Boolean.\nSynonyms:\nformz_lustre/definition.boolean_field\nformz_lustre/definition boolean_field","url":"formz_lustre/definition.html#boolean_field"},{"doc":"formz_lustre/definition","title":"choices_field","content":"pub fn choices_field(\n  variants: List(#(String, a)),\n  stub stub: a,\n) -&gt; Definition(Widget(b), a, Option(a))\n Creates a `&lt;select&gt;` input.  Takes a tuple of `#(String, String)` where the first\n item in the tuple is the label, and the second item can be any Gleam type and\n is the value that would be parsed for a given selection.\n\n Because of how you build `formz` forms, you need to provide a stub of\n the value type.  Is this annoying?  Would it be more or less annoying if I\n required a non-empty list for the variants instead? I&#39;m not sure.  Let me know!\nSynonyms:\nformz_lustre/definition.choices_field\nformz_lustre/definition choices_field","url":"formz_lustre/definition.html#choices_field"},{"doc":"formz_lustre/definition","title":"email_field","content":"pub fn email_field() -&gt; Definition(\n  Widget(a),\n  String,\n  Option(String),\n)\n Create an email form input. Parsed as a String but must\n look like an email address, i.e. the string has an `@`.\nSynonyms:\nformz_lustre/definition.email_field\nformz_lustre/definition email_field","url":"formz_lustre/definition.html#email_field"},{"doc":"formz_lustre/definition","title":"integer_field","content":"pub fn integer_field() -&gt; Definition(Widget(a), Int, Option(Int))\n Create a whole number form input. Parsed as an Int.\nSynonyms:\nformz_lustre/definition.integer_field\nformz_lustre/definition integer_field","url":"formz_lustre/definition.html#integer_field"},{"doc":"formz_lustre/definition","title":"list_field","content":"pub fn list_field(\n  variants: List(String),\n) -&gt; Definition(Widget(a), String, Option(String))\n Creates a `&lt;select&gt;` input from a list of strings.  Validates that the parsed\n value is one of the strings in the list.\nSynonyms:\nformz_lustre/definition.list_field\nformz_lustre/definition list_field","url":"formz_lustre/definition.html#list_field"},{"doc":"formz_lustre/definition","title":"make_hidden","content":"pub fn make_hidden(\n  def: Definition(Widget(a), b, c),\n) -&gt; Definition(Widget(a), b, c)\n\nSynonyms:\nformz_lustre/definition.make_hidden\nformz_lustre/definition make_hidden","url":"formz_lustre/definition.html#make_hidden"},{"doc":"formz_lustre/definition","title":"number_field","content":"pub fn number_field() -&gt; Definition(\n  Widget(a),\n  Float,\n  Option(Float),\n)\n Create a number form input. Parsed as a Float.\nSynonyms:\nformz_lustre/definition.number_field\nformz_lustre/definition number_field","url":"formz_lustre/definition.html#number_field"},{"doc":"formz_lustre/definition","title":"password_field","content":"pub fn password_field() -&gt; Definition(\n  Widget(a),\n  String,\n  Option(String),\n)\n Create a password form input, which hides the input value. Parsed as a String\nSynonyms:\nformz_lustre/definition.password_field\nformz_lustre/definition password_field","url":"formz_lustre/definition.html#password_field"},{"doc":"formz_lustre/definition","title":"text_field","content":"pub fn text_field() -&gt; Definition(Widget(a), String, String)\n Create a basic form input. Parsed as a String.\nSynonyms:\nformz_lustre/definition.text_field\nformz_lustre/definition text_field","url":"formz_lustre/definition.html#text_field"},{"doc":"formz_lustre/definition","title":"formz_lustre/definition","content":" Hopefully these are pretty self-explanatory. I haven&#39;t provided any\n examples here, as these are all used to build HTML forms and I don&#39;t know\n how helpful it would be to see the raw HTML.  If you&#39;d like to see\n examples of these in action, please see the [formz_demo](https://github.com/bentomas/formz/tree/main/formz_demo)\n example project.","url":"formz_lustre/definition.html"},{"doc":"formz_lustre/generator","title":"ElementAndId","content":"pub type ElementAndId(msg) {\n  ElementAndId(element: element.Element(msg), id: String)\n}\n\nElementAndId(element: element.Element(msg), id: String)\n\n\nSynonyms:\nformz_lustre/generator.ElementAndId\nformz_lustre/generator ElementAndId","url":"formz_lustre/generator.html#ElementAndId"},{"doc":"formz_lustre/generator","title":"build","content":"pub fn build(form: Form(Widget(a), b)) -&gt; Element(a)\n\nSynonyms:\nformz_lustre/generator.build\nformz_lustre/generator build","url":"formz_lustre/generator.html#build"},{"doc":"formz_lustre/generator","title":"build_item","content":"pub fn build_item(item: Item(Widget(a))) -&gt; Element(a)\n\nSynonyms:\nformz_lustre/generator.build_item\nformz_lustre/generator build_item","url":"formz_lustre/generator.html#build_item"},{"doc":"formz_lustre/generator","title":"error","content":"pub fn error(\n  id: String,\n  state: InputState,\n  element: fn(List(Attribute(a)), List(Element(a))) -&gt; Element(a),\n  class_name: String,\n) -&gt; ElementAndId(a)\n\nSynonyms:\nformz_lustre/generator.error\nformz_lustre/generator error","url":"formz_lustre/generator.html#error"},{"doc":"formz_lustre/generator","title":"help_text","content":"pub fn help_text(\n  id: String,\n  help_text: String,\n  element: fn(List(Attribute(a)), List(Element(a))) -&gt; Element(a),\n  class_name: String,\n) -&gt; ElementAndId(a)\n\nSynonyms:\nformz_lustre/generator.help_text\nformz_lustre/generator help_text","url":"formz_lustre/generator.html#help_text"},{"doc":"formz_lustre/generator","title":"label","content":"pub fn label(id: String, label: String) -&gt; ElementAndId(a)\n\nSynonyms:\nformz_lustre/generator.label\nformz_lustre/generator label","url":"formz_lustre/generator.html#label"},{"doc":"formz_lustre/generator","title":"legend","content":"pub fn legend(id: String, label: String) -&gt; ElementAndId(a)\n\nSynonyms:\nformz_lustre/generator.legend\nformz_lustre/generator legend","url":"formz_lustre/generator.html#legend"},{"doc":"formz_lustre/generator","title":"formz_lustre/generator","content":"","url":"formz_lustre/generator.html"}]);